{% for interface, options in ifupdown2__interfaces.items() %}
{## Template interface options ##}
auto {{ interface }}
{## Set interface type ##}
{% if options.type is defined and options.type == 'loopback' %}
iface {{ interface }} inet loopback
{% elif options.dhcp|d(false) %}
iface {{ interface }} inet dhcp
{% else %}
iface {{ interface }}
{% endif %}
    {% if options.link_type is defined %}
    link-type {{ options.link_type }}
    {% endif %}
    {## Set Interface Admin State ##}
    {% if not options.admin_state|default(true) %}
    link-down yes
    {% endif -%}
    {## Interface Description ##}
    {% if options.description is defined and options.description != '' %}
    alias {{ options.description|replace('\n', '') }}
    {% endif -%}
    {## Interface MTU ##}
    {% if not options.type|d('') == 'loopback' %}
    mtu {{ options.mtu|default(9216, true) }}
    {% endif %}
    {% if options.linkspeed is defined %}
    link-speed {{ options.linkspeed }}
    {% endif %}
    {% if not options.autoneg|default(true) %}
    link-autoneg off
    {% endif %}
    {% if options.link_fec is defined %}
    link-fec {{ options.link_fec }}
    {% endif -%}
    {## Configure adresses ##}
    {% if options.address is defined %}
    {% for address in options.address %}
    address {{ address }}
    {% endfor %}
    {% endif -%}
    {## Configure gateways ##}
    {% if options.gateway is defined %}
    {% for gateway in options.gateway %}
    gateway {{ gateway }}
    {% endfor %}
    {## Configure Interface VRF ##}
    {% if options.vrf is defined %}
    vrf {{ options.vrf }}
    {% elif options.type|default('') == "management" or interface == 'eth0' %}
    vrf mgmt
    {% endif %}
{% endif %}

{% endfor %}

{## Template mgmt-vrf (when enabled) ##}
{% if ifupdown2__enable_mgmt_vrf %}
auto mgmt
iface mgmt
    address 127.0.0.1/8
    address ::1/128
    vrf-table auto
{% endif %}
